/**********************************************************************
  sarg̃Zbg
  $Id: sim_setarg.c,v 1.4 2006/03/19 07:35:56 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int sim_setarg( struct MACHINE_RESOURCE *mres , struct GETOPT_ARG *args , int start )
{
  int i ;
  int arg_start ;
  int arg_str_top ;
  int len ;
  int err ; 
  
  if( XGETOPT_REFAGCP(args) > ARGC_MAX_SIZE ){
    return( SETARG_TOO_MANY_ARGS ) ;
  }
  for( i=0,len=0 ; i<XGETOPT_REFAGCP(args) ; i++ ){
    len += strlen(XGETOPT_REFARGP(args,i))+1 ;
  }
  if( len > ARGV_MAX_SIZE ){
    return( SETARG_TOO_MANY_ARGS ) ;
  }
  
  arg_start   = mres->mem_size[TEXT_SEG_TOP] - ARG_START_OFFSET ;
  arg_str_top = mres->mem_size[TEXT_SEG_TOP] - ARG_STR_TOP_OFFSET ;
  
  mres->GPR[3].rl=XGETOPT_REFAGCP(args) - start ; /*** argc̐ݒ ***/
  mres->GPR[4].rl=arg_start                     ; /*** argv̐ݒ ***/
  
  err=0 ;
  for( i=start ; i<XGETOPT_REFAGCP(args) ; i++ ){
    if( mres->mem[seg(arg_start+0)]==NULL || 
	mres->mem_size[seg(arg_start+0)] < lad(arg_start+0) ){
      err=1 ; break ;
    }
    mres->mem[seg(arg_start+0)][lad(arg_start+0)]=(arg_str_top & 0xff000000)>>24 ;
    if( mres->mem[seg(arg_start+1)]==NULL || 
	mres->mem_size[seg(arg_start+1)] < lad(arg_start+1) ){
      err=1 ; break ;
    }
    mres->mem[seg(arg_start+1)][lad(arg_start+1)]=(arg_str_top & 0x00ff0000)>>16 ;
    if( mres->mem[seg(arg_start+2)]==NULL || 
	mres->mem_size[seg(arg_start+2)] < lad(arg_start+2) ){
      err=1 ; break ;
    }
    mres->mem[seg(arg_start+2)][lad(arg_start+2)]=(arg_str_top & 0x0000ff00)>> 8 ;
    if( mres->mem[seg(arg_start+3)]==NULL || 
	mres->mem_size[seg(arg_start+3)] < lad(arg_start+3) ){
      err=1 ; break ;
    }
    mres->mem[seg(arg_start+3)][lad(arg_start+3)]=(arg_str_top & 0x000000ff)     ;
    arg_start+=4 ;
    
    len = strlen( XGETOPT_REFARGP(args,i) ) ;
    strcpy( (char*)&mres->mem[seg(arg_str_top)][lad(arg_str_top)], XGETOPT_REFARGP(args,i) ) ;
    arg_str_top += len ;
    mres->mem[seg(arg_str_top)][lad(arg_str_top)]='\0' ;
    arg_str_top++ ;
  }
  
  if( err==0 ) return( NORMAL_EXIT ) ;
  else         return( MEM_ACCESS_FAULT ) ;
}

/*******************************************************************
  Segment=TEXT_SEG_TOP ̃Ԃ̍Ō4096bytearg̈
  ƂĎgpB
*******************************************************************/
